/***************************************************************

Copyright 2011 - NY00123
Copyright 2011 - Turrican

This file is part of YANG.

You're not allowed to give YANG and derivatives of it to anyone.
IN ADDITION, THIS FILE IS PROVIDED WITHOUT ANY KIND OF WARRANTY,
WHETHER EXPRESSED OR IMPLIED.

***************************************************************/

#ifndef _YANG_ADVANCEDDIALOG_H_
#define _YANG_ADVANCEDDIALOG_H_

#include <wx/wxprec.h>

#ifdef __BORLANDC__
#pragma hdrstop
#endif

#include "theme.h"

#define ID_EDUKE32USERPATHCHECKBOX 1000
#define ID_SELECTEDUKE32USERPATH 1001
#define ID_IDUKE3DUSERPATHCHECKBOX 1002
#define ID_DUKE3DWUSERPATHCHECKBOX 1003
#define ID_SELECTDUKE3DWUSERPATH 1004
#define ID_SELECTIDUKE3DUSERPATH 1005
#define ID_JFSWUSERPATHCHECKBOX 1006
#define ID_SELECTJFSWUSERPATH 1007
#define ID_SELECTBANLISTFILE 1008
#define ID_BROWSERCHECKBOX 1009
#define ID_LOCATEBROWSER 1010
#define ID_SOUNDCMDCHECKBOX 1011
#define ID_SERVERLISTADD 1012
#define ID_SERVERLISTREM 1013

class AdvDialog : public YANGDialog
{
public:
	AdvDialog();
	~AdvDialog();
	void OnSelectDir(wxCommandEvent& event);
	void OnLocateBanListTextFile(wxCommandEvent& event);
	void OnLocateExec(wxCommandEvent& event);
	void OnCheckBoxClick(wxCommandEvent& event);

	void OnServerListAdd(wxCommandEvent& event);
	void OnServerListRem(wxCommandEvent& event);

	//void OnApply(wxCommandEvent& event);
	void OnCancel(wxCommandEvent& event);
	void OnOk(wxCommandEvent& event);
	void ApplySettings();
private:
	YANGNotebook* m_advancednotebook;
	YANGPanel* m_advpanel;
	wxStaticText* m_userpathstaticText;
	YANGCheckBox* m_eduke32userpathcheckBox;
	YANGTextCtrl* m_eduke32userpathtextCtrl;
	YANGButton* m_eduke32userpathbutton;
	YANGCheckBox* m_duke3dwuserpathcheckBox;
	YANGTextCtrl* m_duke3dwuserpathtextCtrl;
	YANGButton* m_duke3dwuserpathbutton;
	YANGCheckBox* m_iduke3duserpathcheckBox;
	YANGTextCtrl* m_iduke3duserpathtextCtrl;
	YANGButton* m_iduke3duserpathbutton;
	YANGCheckBox* m_jfswuserpathcheckBox;
	YANGTextCtrl* m_jfswuserpathtextCtrl;
	YANGButton* m_jfswuserpathbutton;
	wxStaticText* m_banliststaticText;
	YANGTextCtrl* m_banlisttextCtrl;
	YANGButton* m_banlistbutton;
	YANGCheckBox* m_overridebrowsercheckBox;
	YANGTextCtrl* m_browsertextCtrl;
	YANGButton* m_browserlocatebutton;
	YANGCheckBox* m_overridesoundcheckBox;
	YANGTextCtrl* m_soundcmdtextCtrl;
	YANGCheckBox* m_localipoptimizecheckBox;
#ifndef __WXMSW__
	wxStaticText* m_terminalstaticText;
	YANGTextCtrl* m_terminaltextCtrl;
#endif
	YANGPanel* m_extraserverspanel;
	wxStaticText* m_extraserveraddrstaticText;
	wxStaticText* m_extraserverportnumstaticText;
	YANGTextCtrl* m_extraserverhostaddrtextCtrl;
	wxStaticText* m_extraserverseparatorstaticText;
	YANGTextCtrl* m_extraserverportnumtextCtrl;
	YANGButton* m_extraserveraddbutton;
	YANGListBox* m_extraserverlistBox;
	YANGButton* m_extraserverrembutton;

	wxStdDialogButtonSizer* m_advsdbSizer;
	YANGButton* m_advsdbSizerOK;
	YANGButton* m_advsdbSizerCancel;

	wxArrayString m_extra_addrs;
	wxArrayLong m_extra_portnums;

	DECLARE_EVENT_TABLE()
};

#endif

