/***************************************************************

Copyright 2011 - NY00123
Copyright 2011 - Turrican

This file is part of YANG.

You're not allowed to give YANG and derivatives of it to anyone.
IN ADDITION, THIS FILE IS PROVIDED WITHOUT ANY KIND OF WARRANTY,
WHETHER EXPRESSED OR IMPLIED.

***************************************************************/

#ifndef _YANG_FILETRANSFER_H_
#define _YANG_FILETRANSFER_H_

#include <wx/wxprec.h>

#ifdef __BORLANDC__
#pragma hdrstop
#endif

#ifndef WX_PRECOMP
#include <wx/socket.h>
#include <wx/wfstream.h>
#endif

#define ID_TRANSFERTHREADEND (wxID_LOWEST-1)

enum TransferRequestType { TRANSFERREQUEST_NONE,
TRANSFERREQUEST_DOWNLOAD, TRANSFERREQUEST_UPLOAD };
enum TransferStateType { TRANSFERSTATE_NONE, TRANSFERSTATE_PENDING,
TRANSFERSTATE_BUSY, TRANSFERSTATE_ABORTED };

class FileSendThread : public wxThread
{
public:
	FileSendThread(wxSocketBase* sock, wxWindow* window,
		wxFile* fp, TransferStateType* transfer_state_ptr);
	virtual void *Entry();
private:
	wxSocketBase *m_sock;
	wxWindow* m_window;
	wxFile* m_fp;
	TransferStateType* m_transfer_state_ptr;
};

class FileReceiveThread : public wxThread
{
public:
	FileReceiveThread(wxSocketBase* sock, wxWindow* window,
		wxFile* fp, wxULongLong filesize,
		TransferStateType* transfer_state_ptr);
	virtual void *Entry();
private:
	wxSocketBase *m_sock;
	wxWindow* m_window;
	wxFile* m_fp;
	wxULongLong m_filesize;
	TransferStateType* m_transfer_state_ptr;
};

#endif
