/***************************************************************

Copyright 2011 - NY00123
Copyright 2011 - Turrican

This file is part of YANG.

You're not allowed to give YANG and derivatives of it to anyone.
IN ADDITION, THIS FILE IS PROVIDED WITHOUT ANY KIND OF WARRANTY,
WHETHER EXPRESSED OR IMPLIED.

***************************************************************/

#ifndef _YANG_LOOKANDFEELDIALOG_H_
#define _YANG_LOOKANDFEELDIALOG_H_

#include <wx/wxprec.h>

#ifdef __BORLANDC__
#pragma hdrstop
#endif

#ifndef WX_PRECOMP
#include <wx/cmndata.h>
#endif

#include "theme.h"

///////////////////////////////////////////////////////////////////////////

#define ID_LOOKANDFEELUSECUSTOMFONT 1000
#define ID_LOOKANDFEELUSECUSTOMCOLORS 1001
#define ID_LOOKANDFEELFONTCHOICE 1002
#define ID_LOOKANDFEELFONTSIZECOMBOBOX 1003
#define ID_LOOKANDFEELTEXTCOLORCHOICE 1004
#define ID_LOOKANDFEELBACKGROUNDCOLORCHOICE 1005

class LookAndFeelDialog : public YANGDialog 
{
public:
	LookAndFeelDialog(wxWindow* parent, bool isHost);
	//~LookAndFeelDialog();
	void ShowDialog();
	void OnUseCustomStyleAnyCheck(wxCommandEvent& event);
	void OnFontChoice(wxCommandEvent& event);
	void OnFontSizeUpdate(wxCommandEvent& event);
	void OnTextColorSet(wxHyperlinkEvent& event);
	void OnBackgroundColorSet(wxHyperlinkEvent& event);
	void OnOk(wxCommandEvent& event);
	//void OnCancel(wxCommandEvent& event);

private:
	wxWindow* m_parent;
	bool m_is_host;

	YANGPanel* m_LookAndFeelpanel;
	//YANGCheckBox* m_darkthemecheckBox;
	YANGCheckBox* m_chatfontlayoutcheckBox;
	YANGCheckBox* m_chatcolorlayoutcheckBox;
	wxStaticText* m_fontstaticText;
	YANGChoice* m_fontchoice;
	wxStaticText* m_fontsizestaticText;
	YANGComboBox* m_fontsizecomboBox;
	YANGHyperlinkCtrl* m_textcolorhyperlink;
	YANGHyperlinkCtrl* m_backcolorhyperlink;
	wxStaticText* m_chatsamplestaticText;
	YANGTextCtrl* m_chatsampletextCtrl;
	wxStdDialogButtonSizer* m_LookAndFeelsdbSizer;
	YANGButton* m_LookAndFeelsdbSizerOK;
	YANGButton* m_LookAndFeelsdbSizerCancel;

	void RefreshSampleText();

	wxFont m_font, m_def_font;
	wxColour m_textcolor, m_backcolor, m_def_textcolor, m_def_backcolor;
	wxColourData m_colordata;

	DECLARE_EVENT_TABLE()
};

#endif //__wxfbguis__

