/***************************************************************

Copyright 2011 - NY00123
Copyright 2011 - Turrican

This file is part of YANG.

You're not allowed to give YANG and derivatives of it to anyone.
IN ADDITION, THIS FILE IS PROVIDED WITHOUT ANY KIND OF WARRANTY,
WHETHER EXPRESSED OR IMPLIED.

***************************************************************/

#ifndef _YANGMASTER_H_
#define _YANGMASTER_H_

#include <wx/wxprec.h>

#ifdef __BORLANDC__
#pragma hdrstop
#endif

#ifndef WX_PRECOMP
//#include <wx/app.h>
#include <wx/socket.h>
#include <wx/stopwatch.h>
#endif

#define MASTER_DEFAULT_PORT_NUM 8500
#define MASTER_DEFAULT_MAX_CLIENTS 64
#define MASTER_DEFAULT_MAX_CONNECTIONS_PER_IP 8
#define MASTER_DEFAULT_MAX_ROOMS 16
#define MASTER_DEFAULT_MAX_ROOMS_PER_IP 2
#define MASTER_DEFAULT_BANLIST_REFRESH_TIME 0

class BanListTimerThread : public wxThread
{
public:
	BanListTimerThread(long refresh_time);
	virtual void *Entry();
private:
	wxStopWatch m_stopwatch;
	long m_refresh_time;
};

class ClientThread : public wxThread
{
public:
	ClientThread(wxSocketBase* sock, const wxString& address);
	virtual void *Entry();
private:
	wxSocketBase *m_sock;
	wxString m_addr;
};

class ServerThread : public wxThread
{
public:
	ServerThread(wxSocketServer* server);
	virtual void *Entry();
private:
	wxSocketServer *m_server;
};
/*
class YANGMASTERApp : public wxApp
{
public:
// Called on application startup
virtual bool OnInit();
};
*/
#endif
