/***************************************************************

Copyright 2011 - NY00123
Copyright 2011 - Turrican

This file is part of YANG.

You're not allowed to give YANG and derivatives of it to anyone.
IN ADDITION, THIS FILE IS PROVIDED WITHOUT ANY KIND OF WARRANTY,
WHETHER EXPRESSED OR IMPLIED.

***************************************************************/

#ifndef _YANGMASTER_BANLIST_H_
#define _YANGMASTER_BANLIST_H_

#include <wx/wxprec.h>

#ifdef __BORLANDC__
#pragma hdrstop
#endif

#ifndef WX_PRECOMP
#include <wx/string.h>
#endif

typedef struct
{
	wxString hostname, address;
} MasterBanList_Client;

struct MasterBanList_Node
{
	MasterBanList_Client client;
	MasterBanList_Node *next;
};

typedef MasterBanList_Node* MasterBanList_LinkedList;

class MasterBanList
{
public:
	MasterBanList();
	void Load(const wxArrayString& filenames);
	bool IsBanned(const wxString& address);
	MasterBanList_Client* m_clients;
	long m_num_of_clients;
	wxCriticalSection m_critical_section;
private:
	void SetClients(MasterBanList_LinkedList clients_linked_list, long new_num_of_clients);
};

#endif
