/***************************************************************

Copyright 2011 - NY00123
Copyright 2011 - Turrican

This file is part of YANG.

You're not allowed to give YANG and derivatives of it to anyone.
IN ADDITION, THIS FILE IS PROVIDED WITHOUT ANY KIND OF WARRANTY,
WHETHER EXPRESSED OR IMPLIED.

***************************************************************/

#include <wx/wxprec.h>

#ifdef __BORLANDC__
#pragma hdrstop
#endif

#ifndef WX_PRECOMP
#include <wx/socket.h>
#endif

#include "master_clientstable.h"

MasterClientsTable::MasterClientsTable(int max_clients)
{
	m_clients = new MasterClient[max_clients];
	m_max_num_of_clients = max_clients;
	m_num_of_clients = 0;
}

MasterClientsTable::~MasterClientsTable()
{
	delete [] m_clients;
}

int MasterClientsTable::Count(const wxString& address)
{
	int l_result = 0, l_loop_var;
	wxCriticalSectionLocker l_locker(m_critical_section);
	for (l_loop_var = 0; l_loop_var < m_num_of_clients; l_loop_var++)
		if (m_clients[l_loop_var].address == address)
			l_result++;
	return l_result;
}

bool MasterClientsTable::TryAdd(wxSocketBase* sock)
{
	wxIPV4address l_addr;
	wxCriticalSectionLocker l_locker(m_critical_section);
	if (m_num_of_clients < m_max_num_of_clients)
	{
		m_clients[m_num_of_clients].sock = sock;
		sock->GetPeer(l_addr);
		m_clients[m_num_of_clients].address = l_addr.IPAddress();
		m_num_of_clients++;
		return true;
	}
	return false;
}

void MasterClientsTable::Delete(wxSocketBase* sock)
{
	int l_loop_var;
	wxCriticalSectionLocker l_locker(m_critical_section);
	for (l_loop_var = 0; l_loop_var < m_num_of_clients; l_loop_var++)
		if (m_clients[l_loop_var].sock == sock)
		{
			m_num_of_clients--;
			if (l_loop_var < m_num_of_clients) // A simple move of one array element.
				m_clients[l_loop_var] = m_clients[m_num_of_clients];
			break;
		}
}
