/***************************************************************

Copyright 2011 - NY00123
Copyright 2011 - Turrican

This file is part of YANG.

You're not allowed to give YANG and derivatives of it to anyone.
IN ADDITION, THIS FILE IS PROVIDED WITHOUT ANY KIND OF WARRANTY,
WHETHER EXPRESSED OR IMPLIED.

***************************************************************/

#ifndef _YANGMASTER_ROOMSTABLE_H_
#define _YANGMASTER_ROOMSTABLE_H_

#include <wx/wxprec.h>

#ifdef __BORLANDC__
#pragma hdrstop
#endif

#ifndef WX_PRECOMP
#include <wx/hashmap.h>
#include <wx/socket.h>
#endif

#include "config.h"
#include "common.h"

typedef struct
{
	wxSocketBase* sock;
	wxString address, localip;
	wxString netver;
	long port_num;
	bool password_protected;
	GameType game;
	wxString roomname; // String length should be self-limited in networking code.
	unsigned long /*num_players, */max_num_players, skill;
	bool in_game;
	SourcePortType srcport;
	BloodMPGameT_Type bloodgametype;
	DescentMPGameT_Type descentgametype;
	Descent2MPGameT_Type descent2gametype;
	DN3DMPGameT_Type dn3dgametype;
	SWMPGameT_Type swgametype;
	//DN3DSpawnType dn3dspawn;
	bool launch_usermap;
	wxString usermap; // Same.
	unsigned long epimap_num;
	wxString modname; // Same.
	//bool usemasterslave;
	bool use_crypticpassage;
} RoomInfo;

typedef struct
{
	RoomInfo info;
	wxArrayString players; // Same.
} MasterRoom;

WX_DECLARE_STRING_HASH_MAP( long, IPStrToNumOfRoomsHash );

class MasterRoomsTable
{
public:
	MasterRoomsTable(int max_rooms, int max_rooms_per_ip);
	~MasterRoomsTable();
	int Count(const wxString& address);
	bool IsFull();
	bool TryAdd(MasterRoom& room);
	void UpdateInfo(RoomInfo& room_info);
	void UpdatePlayers(wxSocketBase* sock, const wxArrayString& players);
	void UpdateIps(wxSocketBase* sock, const wxArrayString& ips);
	//void AddNickname(wxSocketBase* sock, const wxString& nickname);
	//void RemNickname(wxSocketBase* sock, const wxString& nickname);
	bool TryGet(int index, MasterRoom& room);
	void Delete(wxSocketBase* sock);
	size_t GetCountByPort(SourcePortType srcport);
	MasterRoom* m_rooms;
	IPStrToNumOfRoomsHash *m_iptorooms_hash;
	int m_num_of_rooms, m_max_num_of_rooms, m_max_num_of_rooms_per_ip;
	size_t m_room_counts_by_port[SOURCEPORT_NUMOFPORTS];
	wxCriticalSection m_critical_section;
};

#endif
