/***************************************************************

Copyright 2011 - NY00123
Copyright 2011 - Turrican

This file is part of YANG.

You're not allowed to give YANG and derivatives of it to anyone.
IN ADDITION, THIS FILE IS PROVIDED WITHOUT ANY KIND OF WARRANTY,
WHETHER EXPRESSED OR IMPLIED.

***************************************************************/

#ifndef _YANG_MPCOMMON_H_
#define _YANG_MPCOMMON_H_

#include <wx/wxprec.h>

#ifdef __BORLANDC__
#pragma hdrstop
#endif

#ifndef WX_PRECOMP
#include <wx/socket.h>
#include <wx/stopwatch.h>
#endif

#include "common.h"
#include "config.h"
#include "file_transfer.h"

#define MAX_NUM_MSG_LINES 512
#define MAX_NUM_CONNECTED_CLIENTS 64

typedef struct
{
	wxString nickname, ingameip;
	long game_port_number;
	wxString os_description;
	bool ready;
} RoomPlayerData;

class RoomPlayersTable
{
public:
	RoomPlayerData players[MAX_NUM_PLAYERS];
	size_t num_players;

	RoomPlayersTable();
	bool Add(const wxString& nickname,
		const wxString& ingameip, long game_port_number);
	bool DelByIndex(size_t index);
	size_t FindIndexByNick(const wxString& nickname);
};

typedef struct
{
	TransferRequestType transferrequest;
	wxString filename;
	long filesize;
	bool awaiting_download;
} TransferRequestData;

class ExtendedRoomPlayersTable : public RoomPlayersTable
{
public:
	TransferRequestData requests[MAX_NUM_PLAYERS];

	ExtendedRoomPlayersTable();
	bool Add(const wxString& nickname,
		const wxString& ingameip, long game_port_number,
		const wxString& os_description, bool ready);
	bool DelByIndex(size_t index);
};

/*
typedef struct
{
wxString nickname, ingameip, filename;
long game_port_number, filesize;
TransferRequestType transferrequest;
} ExtendedRoomPlayerData;

class ExtendedRoomPlayersTable
{
public:
ExtendedRoomPlayerData players[MAX_NUM_PLAYERS];
size_t num_players;

ExtendedRoomPlayersTable();
bool Add(const wxString& nickname,
const wxString& ingameip, long game_port_number);
bool DelByIndex(size_t index);
size_t FindIndexByNick(const wxString& nickname);
};
*/
typedef struct
{
	wxSocketBase* sock;
	wxString peerdetectedip, selfdetectedip, nickname;
	wxStopWatch* stopwatch;
} HostRoomClientData;

class HostRoomClientsTable
{
public:
	HostRoomClientData clients[MAX_NUM_CONNECTED_CLIENTS+1]; // One more for file-transfer.
	size_t num_clients;

	HostRoomClientsTable();
	bool Add(wxSocketBase* sock,
		const wxString& peerdetectedip,//const wxString& selfdetectedip
		wxStopWatch* stopwatch);
	bool PutInRoom(size_t index, size_t inroom_num_clients);
	bool DelBySock(wxSocketBase* sock);
	bool DelByIndex(size_t index);
	size_t FindIndexBySock(wxSocketBase* sock);
};

#endif
