/***************************************************************

Copyright 2011 - NY00123
Copyright 2011 - Turrican

This file is part of YANG.

You're not allowed to give YANG and derivatives of it to anyone.
IN ADDITION, THIS FILE IS PROVIDED WITHOUT ANY KIND OF WARRANTY,
WHETHER EXPRESSED OR IMPLIED.

***************************************************************/

#ifndef _YANG_SRCPORTSDIALOG_H_
#define _YANG_SRCPORTSDIALOG_H_

#include <wx/wxprec.h>

#ifdef __BORLANDC__
#pragma hdrstop
#endif

#ifndef WX_PRECOMP
#include <wx/statline.h>
#endif

#include "config.h"
#include "theme.h"

#define ID_DOSBLOODSWCHECKBOX 1000
#define ID_LOCATEDOSBLOODSW 1001
#define ID_DOSBLOODRGCHECKBOX 1002
#define ID_LOCATEDOSBLOODRG 1003
#define ID_DOSBLOODPPCHECKBOX 1004
#define ID_LOCATEDOSBLOODPP 1005
#define ID_DOSBLOODOUCHECKBOX 1006
#define ID_LOCATEDOSBLOODOU 1007
#define ID_SELECTBLOODMAPSFOLDER 1008

#define ID_DOSDESCENTCHECKBOX 1009
#define ID_LOCATEDOSDESCENT 1010
#define ID_D1XREBIRTHCHECKBOX 1011
#define ID_LOCATED1XREBIRTH 1012
#define ID_SELECTDESCENTMAPSFOLDER 1013

#define ID_DOSDESCENT2CHECKBOX 1014
#define ID_LOCATEDOSDESCENT2 1015
#define ID_D2XREBIRTHCHECKBOX 1016
#define ID_LOCATED2XREBIRTH 1017
#define ID_SELECTDESCENT2MAPSFOLDER 1018

#define ID_DOSDUKESWCHECKBOX 1019
#define ID_LOCATEDOSDUKESW 1020
#define ID_DOSDUKERGCHECKBOX 1021
#define ID_LOCATEDOSDUKERG 1022
#define ID_DOSDUKEAECHECKBOX 1023
#define ID_LOCATEDOSDUKEAE 1024
#define ID_DUKE3DWCHECKBOX 1025
#define ID_LOCATEDUKE3DW 1026
#define ID_EDUKE32CHECKBOX 1027
#define ID_LOCATEEDUKE32 1028
#define ID_IDUKE3DCHECKBOX 1029
#define ID_LOCATEIDUKE3D 1030
#define ID_XDUKECHECKBOX 1031
#define ID_LOCATEXDUKE 1032
#define ID_SELECTDUKEMAPSFOLDER 1033

#define ID_DOSSWSWCHECKBOX 1034
#define ID_LOCATEDOSSWSW 1035
#define ID_DOSSWRGCHECKBOX 1036
#define ID_LOCATEDOSSWRG 1037
#define ID_JFSWCHECKBOX 1038
#define ID_LOCATEJFSW 1039
#define ID_SWPCHECKBOX 1040
#define ID_LOCATESWP 1041
#define ID_SELECTSWMAPSFOLDER 1042

#define ID_SELECTCUSTOMPROFILE 1043
#define ID_ADDNEWCUSTOMPROFILE 1044
#define ID_DELETECUSTOMPROFILE 1045
#define ID_CUSTOMSPONLYCHECKBOX 1046
#define ID_SPEXECUTABLEINPUTTEXT 1047
#define ID_LOCATECUSTOMSP 1048
#define ID_CUSTOMSAMEBINCHECKBOX 1049
#define ID_MPEXECUTABLEINPUTTEXT 1050
#define ID_LOCATECUSTOMMP 1051
#define ID_CUSTOMNOCDRADIOBTN 1052
#define ID_CUSTOMCDLOCATIONRADIOBTN 1053
#define ID_CDLOCATIONINPUTTEXT 1054
#define ID_SELECTCUSTOMCDLOCATION 1055
#define ID_CUSTOMCDIMAGERADIOBTN 1056
#define ID_CDIMAGEINPUTTEXT 1057
#define ID_LOCATECUSTOMCDIMAGE 1058
#define ID_INGAMESUPPORTCHECKBOX 1059
#define ID_NETBIOSCHECKBOX 1060
#define ID_NETBIOSINPUTTEXT 1061
#define ID_LOCATENETBIOS 1062
#define ID_EXTRAARGSINPUTTEXT 1063
#define ID_EXTRAHOSTARGSINPUTTEXT 1064
#define ID_EXTRAALLARGSINPUTTEXT 1065

#define ID_DOSBOXCHECKBOX 1066
#define ID_LOCATEDOSBOX 1067
#define ID_DOSBOXCONFCHECKBOX 1068
#define ID_LOCATEDOSBOXCONF 1069
#define ID_DOSBOXNOCDRADIOBTN 1070
#define ID_DOSBOXCDLOCATIONRADIOBTN 1071
#define ID_SELECTDOSBOXCDLOCATION 1072
#define ID_DOSBOXCDIMAGERADIOBTN 1073
#define ID_LOCATEDOSBOXCDIMAGE 1074
#define ID_BMOUSECHECKBOX 1075
#define ID_LOCATEBMOUSE 1076

#ifndef __WXMSW__
#define ID_WINECHECKBOX 1077
#define ID_LOCATEWINE 1078
#endif

class SRCPortsDialog : public YANGDialog
{
public:
	SRCPortsDialog();
	~SRCPortsDialog();
	void OnLocateFile(wxCommandEvent& event);
	void OnSelectDir(wxCommandEvent& event);
	void OnCheckBoxClick(wxCommandEvent& event);
	void OnRadioBtnClick(wxCommandEvent& event);
//	void OnSelectCustomProfile(wxCommandEvent& event);
	void SelectCustomProfile();
	void OnUpdateTextInput(wxCommandEvent& event);
	void OnAddNewProfile(wxCommandEvent& event);
	void OnDeleteProfile(wxCommandEvent& event);

//	void OnApply(wxCommandEvent& event);
	void OnCancel(wxCommandEvent& event);
	void OnOk(wxCommandEvent& event);
	bool ApplySettings();

private:
	YANGNotebook* m_srcportsnotebook;

	YANGPanel* m_srcportbloodpanel;
	YANGCheckBox* m_dosbloodswavailcheckBox;
	YANGTextCtrl* m_dosbloodswbintextCtrl;
	YANGButton* m_dosbloodswlocatebutton;
	YANGCheckBox* m_dosbloodrgavailcheckBox;
	YANGTextCtrl* m_dosbloodrgbintextCtrl;
	YANGButton* m_dosbloodrglocatebutton;
	YANGCheckBox* m_dosbloodppavailcheckBox;
	YANGTextCtrl* m_dosbloodppbintextCtrl;
	YANGButton* m_dosbloodpplocatebutton;
	YANGCheckBox* m_dosbloodouavailcheckBox;
	YANGTextCtrl* m_dosbloodoubintextCtrl;
	YANGButton* m_dosbloodoulocatebutton;
	wxStaticLine* m_prefbloodstaticline;
	wxStaticText* m_bloodmapsstaticText;
	YANGTextCtrl* m_bloodmapstextCtrl;
	YANGButton* m_bloodmapsselectbutton;

	YANGPanel* m_srcportdescentpanel;
	YANGCheckBox* m_dosdescentavailcheckBox;
	YANGTextCtrl* m_dosdescentbintextCtrl;
	YANGButton* m_dosdescentlocatebutton;
	YANGCheckBox* m_d1xrebirthavailcheckBox;
	YANGTextCtrl* m_d1xrebirthbintextCtrl;
	YANGButton* m_d1xrebirthlocatebutton;
	wxStaticLine* m_prefdescentstaticline;
	wxStaticText* m_descentmapsstaticText;
	YANGTextCtrl* m_descentmapstextCtrl;
	YANGButton* m_descentmapsselectbutton;

	YANGPanel* m_srcportdescent2panel;
	YANGCheckBox* m_dosdescent2availcheckBox;
	YANGTextCtrl* m_dosdescent2bintextCtrl;
	YANGButton* m_dosdescent2locatebutton;
	YANGCheckBox* m_d2xrebirthavailcheckBox;
	YANGTextCtrl* m_d2xrebirthbintextCtrl;
	YANGButton* m_d2xrebirthlocatebutton;
	wxStaticLine* m_prefdescent2staticline;
	wxStaticText* m_descent2mapsstaticText;
	YANGTextCtrl* m_descent2mapstextCtrl;
	YANGButton* m_descent2mapsselectbutton;

	YANGPanel* m_srcportduke3dpanel;
	YANGCheckBox* m_dosdukeswavailcheckBox;
	YANGTextCtrl* m_dosdukeswbintextCtrl;
	YANGButton* m_dosdukeswlocatebutton;
	YANGCheckBox* m_dosdukergavailcheckBox;
	YANGTextCtrl* m_dosdukergbintextCtrl;
	YANGButton* m_dosdukerglocatebutton;
	YANGCheckBox* m_dosdukeaeavailcheckBox;
	YANGTextCtrl* m_dosdukeaebintextCtrl;
	YANGButton* m_dosdukeaelocatebutton;
	YANGCheckBox* m_duke3dwavailcheckBox;
	YANGTextCtrl* m_duke3dwbintextCtrl;
	YANGButton* m_duke3dwlocatebutton;
	YANGCheckBox* m_eduke32availcheckBox;
	YANGTextCtrl* m_eduke32bintextCtrl;
	YANGButton* m_eduke32locatebutton;
	YANGCheckBox* m_iduke3davailcheckBox;
	YANGTextCtrl* m_iduke3dbintextCtrl;
	YANGButton* m_iduke3dlocatebutton;
	YANGCheckBox* m_xdukeavailcheckBox;
	YANGTextCtrl* m_xdukebintextCtrl;
	YANGButton* m_xdukelocatebutton;
	wxStaticLine* m_prefduke3dstaticline;
	wxStaticText* m_duke3dmapsstaticText;
	YANGTextCtrl* m_duke3dmapstextCtrl;
	YANGButton* m_duke3dmapsselectbutton;

	YANGPanel* m_srcportswpanel;
	YANGCheckBox* m_dosswswavailcheckBox;
	YANGTextCtrl* m_dosswswbintextCtrl;
	YANGButton* m_dosswswlocatebutton;
	YANGCheckBox* m_dosswrgavailcheckBox;
	YANGTextCtrl* m_dosswrgbintextCtrl;
	YANGButton* m_dosswrglocatebutton;
	YANGCheckBox* m_jfswavailcheckBox;
	YANGTextCtrl* m_jfswbintextCtrl;
	YANGButton* m_jfswlocatebutton;
	YANGCheckBox* m_swpavailcheckBox;
	YANGTextCtrl* m_swpbintextCtrl;
	YANGButton* m_swplocatebutton;
	wxStaticLine* m_prefswstaticline;
	wxStaticText* m_swmapsstaticText;
	YANGTextCtrl* m_swmapstextCtrl;
	YANGButton* m_swmapsselectbutton;

	YANGPanel* m_srcportcustompanel;
	wxStaticText* m_customprofilestaticText;
	YANGComboBox* m_customprofilechoice;
	YANGBitmapButton* m_customaddnewbutton;
	YANGBitmapButton* m_customdeletebutton;
	wxStaticLine* m_customstaticline;
	YANGCheckBox* m_customsponlycheckBox;
	wxStaticText* m_customspbinstaticText;
	YANGTextCtrl* m_customspbintextCtrl;
	YANGButton* m_customspbinlocatebutton;
	YANGCheckBox* m_customsamebincheckBox;
	wxStaticText* m_custommpbinstaticText;
	YANGTextCtrl* m_custommpbintextCtrl;
	YANGButton* m_custommpbinlocatebutton;
	YANGRadioButton* m_customnocdradioBtn;
	YANGRadioButton* m_customcdlocationradioBtn;
	YANGTextCtrl* m_customcdlocationtextCtrl;
	YANGButton* m_customcdlocationselectbutton;
	YANGRadioButton* m_customcdimageradioBtn;
	YANGTextCtrl* m_customcdimagetextCtrl;
	YANGButton* m_customcdimagelocatebutton;
	YANGCheckBox* m_customingamesupportcheckBox;
	YANGCheckBox* m_customnetbioscheckBox;
	YANGTextCtrl* m_customnetbiostextCtrl;
	YANGButton* m_customnetbioslocatebutton;
	wxStaticText* m_customextraargsstaticText;
	YANGTextCtrl* m_customextraargstextCtrl;
	wxStaticText* m_customextrahostargsstaticText;
	YANGTextCtrl* m_customextrahostargstextCtrl;
	wxStaticText* m_customextraallargsstaticText;
	YANGTextCtrl* m_customextraallargstextCtrl;

	YANGPanel* m_srcportdosboxpanel;
	YANGCheckBox* m_dosboxavailcheckBox;
	YANGTextCtrl* m_dosboxbintextCtrl;
	YANGButton* m_dosboxlocatebutton;
	YANGCheckBox* m_dosboxconfcheckBox;
	YANGTextCtrl* m_dosboxconftextCtrl;
	YANGButton* m_dosboxconflocatebutton;
	YANGRadioButton* m_dosboxnocdradioBtn;
	YANGRadioButton* m_dosboxcdlocationradioBtn;
	YANGTextCtrl* m_dosboxcdlocationtextCtrl;
	YANGButton* m_dosboxcdlocationselectbutton;
	YANGRadioButton* m_dosboxcdimageradioBtn;
	YANGTextCtrl* m_dosboxcdimagetextCtrl;
	YANGButton* m_dosboxcdimagelocatebutton;
	YANGHyperlinkCtrl* m_dosboxhyperlink;
	wxStaticLine* m_dosboxstaticline;
	YANGCheckBox* m_dosboxbmousecheckBox;
	YANGTextCtrl* m_dosboxbmousetextCtrl;
	YANGButton* m_dosboxbmouselocatebutton;
#ifndef __WXMSW__
	YANGPanel* m_srcportwinepanel;
	YANGCheckBox* m_usewinecheckBox;
	YANGTextCtrl* m_winebintextCtrl;
	wxStaticText* m_winestaticText;
	YANGButton* m_winelocatebutton;
#endif
	wxStdDialogButtonSizer* m_srcportssdbSizer;
	YANGButton* m_srcportssdbSizerOK;
	YANGButton* m_srcportssdbSizerCancel;

	int custom_profile_index;

	custom_profile_t *custom_profile_list_temp, *custom_profile_current_temp;

	DECLARE_EVENT_TABLE()
};

#endif

