/***************************************************************

Copyright 2011 - NY00123
Copyright 2011 - Turrican

This file is part of YANG.

You're not allowed to give YANG and derivatives of it to anyone.
IN ADDITION, THIS FILE IS PROVIDED WITHOUT ANY KIND OF WARRANTY,
WHETHER EXPRESSED OR IMPLIED.

***************************************************************/

#ifndef _YANG_TCMODSELECT_DIALOG_H_
#define _YANG_TCMODSELECT_DIALOG_H_

#include <wx/wxprec.h>

#ifdef __BORLANDC__
#pragma hdrstop
#endif

#ifndef WX_PRECOMP
#include <wx/button.h>
#include <wx/panel.h>
#include <wx/stattext.h>
#include <wx/string.h>
#endif

#include "config.h"
#include "theme.h"

#define ID_TCMODSELECTPROFILE 1000

class TCMODSelectDialog : public YANGDialog
{
public:
	TCMODSelectDialog(wxWindow* parent, GameType game, const wxString& modname, const wxString& modconfile, const wxString& moddeffile, bool showmodurl, const wxString& modurl, const wxArrayString& modfiles);

	void OnSelectCustomProfile(wxCommandEvent& event);

	void OnOk(wxCommandEvent& event);
	void OnCancel(wxCommandEvent& event);

	bool tcmodprofile_selected;
	GameType m_game;
	wxArrayString m_modfiles;

private:
	void UpdateFilesList();

	YANGPanel* m_TCMODSelectpanel;
	wxStaticText* m_TCMODSelectroomnamestaticText;
	wxStaticText* m_TCMODSelectstaticText;
	YANGHyperlinkCtrl* m_TCMODSelecthyperlink;
	wxStaticText* m_TCMODSelectprofilestaticText;
	YANGChoice* m_TCMODSelectprofilechoice;
	wxStaticLine* m_TCMODSelectstaticline;
	wxStaticText* m_TCMODSelecthostmodfilesstaticText;
	wxStaticText* m_TCMODSelectclientmodfilesstaticText;
	wxStaticText* m_TCMODSelectmodfilesstaticText;
	YANGListCtrl* m_TCMODSelecthostmodfileslistCtrl;
	YANGListCtrl* m_TCMODSelectclientmodfileslistCtrl;
	wxStaticText* m_TCMODSelectconfilestaticText;
	YANGTextCtrl* m_TCMODSelecthostconfiletextCtrl;
	YANGTextCtrl* m_TCMODSelectclientconfiletextCtrl;
	wxStaticText* m_TCMODSelectdeffilestaticText;
	YANGTextCtrl* m_TCMODSelecthostdeffiletextCtrl;
	YANGTextCtrl* m_TCMODSelectclientdeffiletextCtrl;

	wxStdDialogButtonSizer* m_TCMODSelectsdbSizer;
	YANGButton* m_TCMODSelectsdbSizerOK;
	YANGButton* m_TCMODSelectsdbSizerCancel;

	DECLARE_EVENT_TABLE()
};

#endif
